function dataResample = resampleHeMatrix(heMatrix, nSample)
% resample hC-Matrix to obtain evenly distributed points
%
% THIS IS NO USER FUNCTION

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2013 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.


%% scale data
centerRay = mean(heMatrix, 2);
centerRay = centerRay ./ sum(centerRay);
dataResample.centerRay = centerRay;
% we create a vrep
scaledDataVrep.V = bsxfun(@times, heMatrix, 1./(centerRay'*heMatrix))';
dataResample.heMatrixScaled = scaledDataVrep.V';

%% reduce to convex hull
[dataDimReducedVrep rot x0] = reduceVrepDimension(scaledDataVrep);
% convex hull points
[K V] = convhulln(dataDimReducedVrep.V);
dataDimReducedVrep.V = dataDimReducedVrep.V(unique(K(:)), :);

%% resampling
disD = obtainDistributionDiscrete('polytope', 'poly', dataDimReducedVrep, ...
    'nSample', nSample);
heMatrixResampled = disD.positionMatrix';

removedCoordinates = zeros(size(heMatrixResampled, 1), 1);
dataResampledVrep.V = [heMatrixResampled, removedCoordinates]*rot';
dataResampledVrep = moveVrep(dataResampledVrep, x0);
dataResample.heMatrixResampled = dataResampledVrep.V';


